Index: debian-kernel-rtcds/arch/x86/kernel/smpboot.c
===================================================================
--- debian-kernel-rtcds.orig/arch/x86/kernel/smpboot.c
+++ debian-kernel-rtcds/arch/x86/kernel/smpboot.c
@@ -1559,6 +1559,18 @@ void native_cpu_die(unsigned int cpu)
 	common_cpu_die(cpu);
 }
 
+static DEFINE_PER_CPU(void (*)(void), fe_code);
+
+int is_cpu_taken_by_rcg_model(unsigned int cpu) {
+        return 0 != per_cpu(fe_code, cpu);
+}
+EXPORT_SYMBOL(is_cpu_taken_by_rcg_model);
+
+void set_fe_code_idle(void (*ptr)(void), unsigned int cpu) {
+       per_cpu(fe_code, cpu) = ptr;
+}
+EXPORT_SYMBOL(set_fe_code_idle);
+
 void play_dead_common(void)
 {
 	idle_task_exit();
@@ -1570,6 +1582,10 @@ void play_dead_common(void)
 	 * With physical CPU hotplug, we should halt the cpu
 	 */
 	local_irq_disable();
+        if (per_cpu(fe_code, smp_processor_id())) {
+	       // Execute front-end code
+	       (*per_cpu(fe_code, smp_processor_id()))();
+	}
 }
 
 static bool wakeup_cpu0(void)
